<script>
/**
 * Upload file component.
 */
export default {

	/**
	 * @property {string} label - label to display
	 * @property {string} accept - uploads to accept. default is text/json.
	 */
	props:['label', 'accept'],
	methods:{

		/**
		 * Files selected
		 */
		fileSelect(e) {

			e.stopPropagation();
			e.preventDefault();

			this.$emit( 'load-file', e.target.files );

		},

		/**
		 * files dropped.
		 */
		fileDrop(e){
			e.stopPropagation();
			e.preventDefault();

			e.target.classList.remove('hilite');

			const dt = e.dataTransfer;
			this.$emit('load-file', dt.files);

		},
		fileDrag(e){
			e.stopPropagation();
			e.preventDefault();
			e.currentTarget.classList.add('hilite');
		},
		dragOut(e){
			e.stopPropagation();
			e.preventDefault();
			e.currentTarget.classList.remove('hilite');
		},

	}

}
</script>

<template>
	<div>
		<!-- visible button handles drop ability -->
		<div :id="elmId('drop-file')"
			@click="$refs.fileInput.click()"
			@drop="fileDrop" @dragover="fileDrag"
			@dragleave.capture.stop="dragOut" name="[Drop Save]">{{label}}</div>

		<label :for="elmId('upload')">{{label}}</label>
		<input ref="fileInput" type="file" @change="fileSelect" :id="elmId('upload')" :accept="accept">
	</div>
</template>

<style scoped>

input[type="file"] {
	display:none;
}

button {
	border: 4px dashed grey;
}

</style>